<?php
/*
 * @author Dennis Reil <dennis.reil@offis.de>
 * @author Nico Mueller <nico.mueller@uni-oldenburg.de>
 * @author Michael Riehemann <michael.riehemann@uni-oldenburg.de>
 * @version 1.2
 *
 */
$ABSOLUTE_PATH_STUDIP = $GLOBALS['ABSOLUTE_PATH_STUDIP'];
$RELATIVE_PATH_CALENDAR = $GLOBALS['RELATIVE_PATH_CALENDAR'];
$CALENDAR_DRIVER = $GLOBALS['CALENDAR_DRIVER'];
/**
 *
 *
 *
 */
class PortalTipsTricksPlugin extends AbstractStudIPPortalPlugin
{
	// debug
	var $debug = false;
	// connection
	var $conn = NULL;
	// user obj
	var $user = NULL;
	// permissions
	var $permissions;
	// user obj
	var $user_class = NULL;
	// user obj
	var $teacher_class = NULL;
	// init later
	var $return_link = '';
	// init later
	var $home_page_username = '';
	// error
	var $error_msg = "Eingabe NICHT erfolgreich &uuml;bernommen.<br>ERROR : ";
	// ok
	var $OK_message = "Eingabe erfolgreich &uuml;bernommen.";


	/*
	 * ##############################################################
	 * Plugin functions
	 * ##############################################################
	 */

	/**
	 * Constructor
	 */
	function PortalTipsTricksPlugin()
	{
		// set navigation
		parent::AbstractStudIPPortalPlugin();
		$nav = new PluginNavigation();
		$nav->setDisplayname(_("Tipps und Tricks"));
		$this->setNavigation($nav);
		// user
		$this->user = $this->getUser();
		// permission
		$this->permissions = $this->user->getPermission();
		// get connection
		$this->conn =& PluginEngine::getPluginDatabaseConnection();
		// icon
		$this->setPluginiconname("img/info.gif");
	}



	/**
	 *	Getter
	 */
	function getPluginname()
	{
  		return _("PortalTipsTricksPlugin");
	}

	/**
	 *	Main entry method for showing the tip of the day
	 */
 	function showOverview()
 	{
 		echo _("<p><b>Wu&szlig;ten sie schon, da&szlig; ..</b></p>");
 		if(isset($_REQUEST["show_tips"]))
 		{
 			$this->showTipOfTheDay(true);
 		}
 		else
 		{
 			$this->showTipOfTheDay(false);
 		}
 	}

	/**
	 *	Main entry method for administration and visualization of all existing tips
	 */
	function showAdministrationPage()
	{
		if($this->permissions->hasAdminPermission())
		{
			$this->showAllTips(true);
		}
		else
		{
			$this->showAllTips(false);
		}
	}

	/**
	 *	Not used for portal plugins
	 */
	function show($subnavi)
	{
	} // end show function

	/*
	 * ##############################################################
	 * util functions
	 * ##############################################################
	 */
	function showInfo($msg) {
		StudIPTemplateEngine :: showInfoMessage(sprintf($msg));
	}

	function showError($msg) {
		StudIPTemplateEngine :: showErrorMessage(sprintf($msg));
	}

	function showSuccess($msg) {
		StudIPTemplateEngine :: showSuccessMessage(sprintf($msg));
	}

	/*
	 * ##############################################################
	 * logic functions
	 * ##############################################################
	 */


	function showTipOfTheDay($full)
	{
		$date = date("z");//day of the year max 365/366 = max number of tips

		$auth_result = $this->conn->execute("select perms from auth_user_md5 where user_id = '".$GLOBALS['auth']->auth['uid']."'");
		$result = $this->conn->execute("select count(*) from TIPS where ".$auth_result->fields("perms")."='1'");

		if (!$result->EOF)
		{
			$result = $this->conn->execute("select id, content, www, last_access from TIPS where ".$auth_result->fields("perms")." = 1 group by ".$auth_result->fields("perms").", last_access ASC limit 1");

			//if first access, set last_access to now
			if($result->fields("last_access") != bcdiv(time(), 1000, 0))
			{
				$this->conn->execute("update TIPS set last_access = '".bcdiv(time(), 1000, 0)."' where id = '".$result->fields("id")."'");
			}

			//get content and url
			$content = $result->fields("content");

			if($full != "all")
			{
				//if($full == false){
				echo $content."</br>";
				//echo substr($content, 0, 300)."[..]</br>";
				//echo "<p align=\"right\"><a href=\"index.php?show_tips=all\">mehr</a></p>";
			}
			else
			{
				echo $content."</br>";
				?>
				<p><a href="<?= $result->fields("www")?>" target="_blank">Weiterf&uuml;hrende Informationen in der Hilfe</a></p>
				<p align="right"><a href="index.php">weniger</a></p>
				<?
			}
		}
	}

	/**
	 *	Shows all existing tips. Only users with 'root' permission have full access.
	 */
	function showAllTips($edit)
	{
		$cssSw = new cssClassSwitcher(); // Klasse f&uuml;r Zebra-Design
		$cssSw->enableHover();
		echo "\n" . $cssSw->GetHoverJSFunction() . "\n";
		$cssSw->resetClass();

		if($edit == true)
		{
			echo _("<p>Auf dieser Seite k&ouml;nnen sie neue Tipps erstellen bzw. bestehende bearbeiten.</br>
			Es k&ouml;nnen bis zu 365 Tipps erstellt werden, die tagesabh&auml;ngig angezeigt werden.</br>
			Die Sichtbarkeit der Tipps h&auml;ngt von den eingestellten Privilegien ab.
			</p>");

		}

		echo _("<p><b>Wu&szlig;ten sie schon, da&szlig; ..</b></br></p>");
		?>
		<form method="POST" action="<?= PluginEngine::getLink($this,array(),"action")?>">
		<table border="0" cellpadding="4" cellspacing="5">
		<?
		if($edit == true)
		{
			?>
			<tr>
				<td width="50px"></td>
				<td class="<?=$cssSw->getClass()?>" width="150px">
					<textarea name="content_new" type="text" rows="6" cols="50"></textarea>
					<input name="webpage_new" size="67"/>
				</td>
				<td class="<?=$cssSw->getClass()?>" width="100px">
					<input type="checkbox" name="priv_autor_new" value="1" checked="checked"> Autor<br>
				<input type="checkbox" name="priv_tutor_new" value="1" checked="checked"> Tutor<br>
				<input type="checkbox" name="priv_dozent_new" value="1" checked="checked"> Dozent<br>
				<input type="checkbox" name="priv_admin_new" value="1"> Admin<br>
				<input type="checkbox" name="priv_root_new" value="1"> Root<br>
					<?= makeButton("erstellen","input",_("Neuen Tipp erstellen"),"create_tip");?>
				</td>
			</tr>
			<?
	  	}

		$result = $this->conn->execute("select id, content, www, autor, tutor, dozent, admin, root from TIPS");
		while (!$result->EOF)
		{
		 	if($edit == true)
		 	{
				?>
				<tr onmouseover="this.childNodes[1].firstChild.checked = true;">
					<td width="50px"><input type="radio" name="index" value="<?= $result->fields("id")?>"></td>
					<td class="<?=$cssSw->getClass()?>" width="150px">
						<textarea name="content_<?= $result->fields("id")?>" rows="6" cols="50"><?= $result->fields("content")?></textarea></br>
						<input name="webpage_<?= $result->fields("id")?>" size="67" value="<?= $result->fields("www")?>"/>
					</td>
					<td class="<?=$cssSw->getClass()?>" width="100px">
						<input type="checkbox" name="priv_autor_<?= $result->fields("id")?>" value="1" <?if($result->fields("autor") == '1'){?>checked="checked"<?}?>> Autor<br>
    					<input type="checkbox" name="priv_tutor_<?= $result->fields("id")?>" value="1" <?if($result->fields("tutor") == '1'){?>checked="checked"<?}?>> Tutor<br>
    					<input type="checkbox" name="priv_dozent_<?= $result->fields("id")?>" value="1" <?if($result->fields("dozent") == '1'){?>checked="checked"<?}?>> Dozent<br>
    					<input type="checkbox" name="priv_admin_<?= $result->fields("id")?>" value="1" <?if($result->fields("admin") == '1'){?>checked="checked"<?}?>> Admin<br>
    					<input type="checkbox" name="priv_root_<?= $result->fields("id")?>" value="1" <?if($result->fields("root") == '1'){?>checked="checked"<?}?>> Root<br>
						<?= makeButton("edit","input",_("Tipp editieren"),"edit_tip");?>
						<?= makeButton("entfernen","input",_("Tipp l&ouml;schen"),"delete_tip");?>
					</td>
				</tr>
				<?
			}
			else
			{
				?>
				<tr>
					<td class="<?=$cssSw->getClass()?>" width="600px">
					<?
					echo $result->fields("content");
					$www = $result->fields("www");
					if($www != "")
					{
						?>
						<a href="<?= $result->fields("www")?>" target="_blank">Weiterf&uuml;hrende Informationen in der Hilfe</a></td>
						<?
					}
					?>
				</tr>
				<?
			}
			$result->MoveNext();
		}
		?>
		</table>
		</form>
		<?
	}

	/**
	 * Occuring actions on existing and new tips are processed here
	 *
	 */
	function action()
	{
		if (isset($_REQUEST["create_tip_x"]))
		{
			//the last_access should be yesterday, so it will not be displayed today!
			$result = $this->conn->execute("INSERT INTO TIPS (content, www, mkdate, last_access, autor, tutor, dozent, admin, root) VALUES('".$_REQUEST['content_new']."', '".$_REQUEST['webpage_new']."','".time()."', '".bcdiv(time()-1000, 1000, 0)."', '".$_REQUEST['priv_autor_new']."', '".$_REQUEST['priv_tutor_new']."', '".$_REQUEST['priv_dozent_new']."', '".$_REQUEST['priv_admin_new']."', '".$_REQUEST['priv_root_new']."')");
			if ($result != "")$this->showSuccess("Der Tipp wurde erfolgreich angelegt!");
			else $this->showError("Der Tipp konnte nicht angelegt werden!");

		}
		else if(isset($_REQUEST["edit_tip_x"]))
		{
			$result = $this->conn->execute("UPDATE TIPS set content = '".$_REQUEST['content_'.$_REQUEST['index']]."', www = '".$_REQUEST['webpage_'.$_REQUEST['index']]."', mkdate = '".time()."', autor = '".$_REQUEST['priv_autor_'.$_REQUEST['index']]."', tutor = '".$_REQUEST['priv_tutor_'.$_REQUEST['index']]."', dozent = '".$_REQUEST['priv_dozent_'.$_REQUEST['index']]."', admin = '".$_REQUEST['priv_admin_'.$_REQUEST['index']]."', root = '".$_REQUEST['priv_root_'.$_REQUEST['index']]."' WHERE id ='".$_REQUEST['index']."'");
			if ($result != "")$this->showSuccess("Der Tipp wurde erfolgreich editiert!");
			else $this->showError("Der Tipp konnte nicht editiert werden!");

		}
		else if(isset($_REQUEST["delete_tip_x"]))
		{
			$result = $this->conn->execute("DELETE FROM TIPS WHERE id = '".$_REQUEST['index']."'");
			if ($result != "") $this->showSuccess("Der Tipp wurde erfolgreich entfernt!");
			else $this->showError("Der Tipp konnte nicht entfernt werden!");

			//Move the last entry to the resulted gap and change the autoincrement_value
			$result = $this->conn->execute("select count(*) from TIPS");
			$number = $result->fields[0];

			//only, if the deleted item is not the last in the list
			if(($number+1) != $_REQUEST['index'])
			{
				$result = $this->conn->execute("UPDATE TIPS set id ='".$_REQUEST['index']."' WHERE id='".($number+1)."'");
				if ($result == "")$this->showError("Die Tipp-Tabelle konnte nicht l&uuml;ckenlos gef&uuml;llt werden. Jeder id muss content zugewiesen werden. &Auml;ndern sie dies bitte manuell, da ansonsten ein leerer Tipp des Tages angezeigt werden kann!");
			}
			//decrement the AUTO_INCREMENT value
			$result = $this->conn->execute("ALTER TABLE TIPS AUTO_INCREMENT = ".($number+1));
			if ($result == "")$this->showError("AUTO_INCREMENT wurde nicht auf ".($number+1)." zur&uuml;ckgesetzt. Bitte �ndern sie dies manuell.");
		}
		//reload this page
		$this->showAllTips(true);
	}

	function actionAction()
	{
		return $this->action();
	}
}

?>